/*
 * DMlab2
 * DM lab2 API
 *
 * OpenAPI spec version: v1
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.MovieModel;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * UserModel
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2019-01-13T19:35:03.027Z")
public class UserModel {
  @SerializedName("id")
  private String id = null;

  @SerializedName("firstName")
  private String firstName = null;

  @SerializedName("lastName")
  private String lastName = null;

  @SerializedName("email")
  private String email = null;

  @SerializedName("gender")
  private String gender = null;

  @SerializedName("birthday")
  private String birthday = null;

  @SerializedName("facebookKey")
  private String facebookKey = null;

  @SerializedName("location")
  private String location = null;

  @SerializedName("favouriteMovies")
  private List<MovieModel> favouriteMovies = null;

  @SerializedName("initChosenMovies")
  private List<MovieModel> initChosenMovies = null;

  @SerializedName("facebookLikedMovies")
  private List<String> facebookLikedMovies = null;

  public UserModel id(String id) {
    this.id = id;
    return this;
  }

  /**
   * Get id
   * @return id
   **/
  @ApiModelProperty(value = "")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public UserModel firstName(String firstName) {
    this.firstName = firstName;
    return this;
  }

  /**
   * Get firstName
   * @return firstName
   **/
  @ApiModelProperty(value = "")
  public String getFirstName() {
    return firstName;
  }

  public void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  public UserModel lastName(String lastName) {
    this.lastName = lastName;
    return this;
  }

  /**
   * Get lastName
   * @return lastName
   **/
  @ApiModelProperty(value = "")
  public String getLastName() {
    return lastName;
  }

  public void setLastName(String lastName) {
    this.lastName = lastName;
  }

  public UserModel email(String email) {
    this.email = email;
    return this;
  }

  /**
   * Get email
   * @return email
   **/
  @ApiModelProperty(value = "")
  public String getEmail() {
    return email;
  }

  public void setEmail(String email) {
    this.email = email;
  }

  public UserModel gender(String gender) {
    this.gender = gender;
    return this;
  }

  /**
   * Get gender
   * @return gender
   **/
  @ApiModelProperty(value = "")
  public String getGender() {
    return gender;
  }

  public void setGender(String gender) {
    this.gender = gender;
  }

  public UserModel birthday(String birthday) {
    this.birthday = birthday;
    return this;
  }

  /**
   * Get birthday
   * @return birthday
   **/
  @ApiModelProperty(value = "")
  public String getBirthday() {
    return birthday;
  }

  public void setBirthday(String birthday) {
    this.birthday = birthday;
  }

  public UserModel facebookKey(String facebookKey) {
    this.facebookKey = facebookKey;
    return this;
  }

  /**
   * Get facebookKey
   * @return facebookKey
   **/
  @ApiModelProperty(value = "")
  public String getFacebookKey() {
    return facebookKey;
  }

  public void setFacebookKey(String facebookKey) {
    this.facebookKey = facebookKey;
  }

  public UserModel location(String location) {
    this.location = location;
    return this;
  }

  /**
   * Get location
   * @return location
   **/
  @ApiModelProperty(value = "")
  public String getLocation() {
    return location;
  }

  public void setLocation(String location) {
    this.location = location;
  }

  public UserModel favouriteMovies(List<MovieModel> favouriteMovies) {
    this.favouriteMovies = favouriteMovies;
    return this;
  }

  public UserModel addFavouriteMoviesItem(MovieModel favouriteMoviesItem) {
    if (this.favouriteMovies == null) {
      this.favouriteMovies = new ArrayList<MovieModel>();
    }
    this.favouriteMovies.add(favouriteMoviesItem);
    return this;
  }

  /**
   * Get favouriteMovies
   * @return favouriteMovies
   **/
  @ApiModelProperty(value = "")
  public List<MovieModel> getFavouriteMovies() {
    return favouriteMovies;
  }

  public void setFavouriteMovies(List<MovieModel> favouriteMovies) {
    this.favouriteMovies = favouriteMovies;
  }

  public UserModel initChosenMovies(List<MovieModel> initChosenMovies) {
    this.initChosenMovies = initChosenMovies;
    return this;
  }

  public UserModel addInitChosenMoviesItem(MovieModel initChosenMoviesItem) {
    if (this.initChosenMovies == null) {
      this.initChosenMovies = new ArrayList<MovieModel>();
    }
    this.initChosenMovies.add(initChosenMoviesItem);
    return this;
  }

  /**
   * Get initChosenMovies
   * @return initChosenMovies
   **/
  @ApiModelProperty(value = "")
  public List<MovieModel> getInitChosenMovies() {
    return initChosenMovies;
  }

  public void setInitChosenMovies(List<MovieModel> initChosenMovies) {
    this.initChosenMovies = initChosenMovies;
  }

  public UserModel facebookLikedMovies(List<String> facebookLikedMovies) {
    this.facebookLikedMovies = facebookLikedMovies;
    return this;
  }

  public UserModel addFacebookLikedMoviesItem(String facebookLikedMoviesItem) {
    if (this.facebookLikedMovies == null) {
      this.facebookLikedMovies = new ArrayList<String>();
    }
    this.facebookLikedMovies.add(facebookLikedMoviesItem);
    return this;
  }

  /**
   * Get facebookLikedMovies
   * @return facebookLikedMovies
   **/
  @ApiModelProperty(value = "")
  public List<String> getFacebookLikedMovies() {
    return facebookLikedMovies;
  }

  public void setFacebookLikedMovies(List<String> facebookLikedMovies) {
    this.facebookLikedMovies = facebookLikedMovies;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UserModel userModel = (UserModel) o;
    return Objects.equals(this.id, userModel.id) &&
            Objects.equals(this.firstName, userModel.firstName) &&
            Objects.equals(this.lastName, userModel.lastName) &&
            Objects.equals(this.email, userModel.email) &&
            Objects.equals(this.gender, userModel.gender) &&
            Objects.equals(this.birthday, userModel.birthday) &&
            Objects.equals(this.facebookKey, userModel.facebookKey) &&
            Objects.equals(this.location, userModel.location) &&
            Objects.equals(this.favouriteMovies, userModel.favouriteMovies) &&
            Objects.equals(this.initChosenMovies, userModel.initChosenMovies) &&
            Objects.equals(this.facebookLikedMovies, userModel.facebookLikedMovies);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, firstName, lastName, email, gender, birthday, facebookKey, location, favouriteMovies, initChosenMovies, facebookLikedMovies);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UserModel {\n");

    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    firstName: ").append(toIndentedString(firstName)).append("\n");
    sb.append("    lastName: ").append(toIndentedString(lastName)).append("\n");
    sb.append("    email: ").append(toIndentedString(email)).append("\n");
    sb.append("    gender: ").append(toIndentedString(gender)).append("\n");
    sb.append("    birthday: ").append(toIndentedString(birthday)).append("\n");
    sb.append("    facebookKey: ").append(toIndentedString(facebookKey)).append("\n");
    sb.append("    location: ").append(toIndentedString(location)).append("\n");
    sb.append("    favouriteMovies: ").append(toIndentedString(favouriteMovies)).append("\n");
    sb.append("    initChosenMovies: ").append(toIndentedString(initChosenMovies)).append("\n");
    sb.append("    facebookLikedMovies: ").append(toIndentedString(facebookLikedMovies)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

